unit dnPxProp;

(*****************************************************************************
Copyright  1997 Dieter Nth
version    : 1.01
date       : 05.07.1997
description:

  Editor for Paradox-style inputmasks
    This could be enhanced with example-masks like in Paradox/DBD ;-)
    Feel free to do so...


******************************************************************************)

interface

uses
  {$IFDEF Ver80} WinTypes, WinProcs, {$ELSE} Windows, {$ENDIF}
  SysUtils, Messages, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls,
  ExtCtrls, Buttons,
  dnPxMask;

type
  TdlgPxMaskEditor = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    edtMask: TEdit;
    btnOK: TBitBtn;
    btnCancel: TBitBtn;
    edtTest: TPxMaskEdit;
    btnRestore: TSpeedButton;
    Memo: TMemo;
    Bevel1: TBevel;
    procedure edtMaskChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnRestoreClick(Sender: TObject);
    procedure edtTestKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure edtTestChange(Sender: TObject);
  private
    { Private declarations }
    OldMask : string;
  end;

var
  dlgPxMaskEditor: TdlgPxMaskEditor;


implementation

uses dnPxCnst;

{$R *.DFM}

{ TdlgPdoxMaskEditor }

procedure TdlgPxMaskEditor.edtTestChange(Sender: TObject);
var
  s : string;
  x : integer;
begin
  with edtTest do
    if length(text) = 0 then
      s := ''
    else
    begin
      s := text;
      if (PxMaskValidate(PxMask, text) <> 0) then
      begin
        x := PxMaskCheckInput(PxMask, s, false);
        if (x = 0) then
          s := LoadStr(SPxMaskInputIncomplete)
        else
        if selStart < x then
          s := LoadStr(SPxMaskInputOkToCursor)
        else
          s := LoadStr(SPxMaskIllegalChar);
      end
      else
        s := LoadStr(SPxMaskInputOK);
    end;
  Memo.text := s;
end;

procedure TdlgPxMaskEditor.edtTestKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_BACK,
    VK_DELETE: edtTestChange(sender);
  end;
end;

procedure TdlgPxMaskEditor.edtMaskChange(Sender: TObject);
begin
  btnRestore.enabled := true;
  edtTest.enabled := false;
  edtTest.Color := clBtnFace;
  try
    if length(edtMask.Text) > 0 then
    begin
      edtTest.PxMask := edtMask.Text;
      Memo.text := LoadStr(SPxMaskSyntaxOK);
      edtTest.enabled := true;
      edtTest.Color := clWindow;
    end
    else
      Memo.text := '';
    btnOK.enabled := true;
  except
    on E: EPxMaskError do
    begin
      Memo.text := E.Message;
      btnOK.enabled := false;
    end;
  end;
end;

procedure TdlgPxMaskEditor.FormActivate(Sender: TObject);
begin
  OldMask := edtMask.Text;
  edtTest.text := '';
  btnRestore.enabled := false;
end;

procedure TdlgPxMaskEditor.btnRestoreClick(Sender: TObject);
begin
  edtMask.Text := OldMask;
  btnRestore.enabled := false;
end;

end.
